# | User | Rating |
---|---|---|

1 | Benq | 3650 |

2 | Radewoosh | 3648 |

3 | tourist | 3579 |

4 | ecnerwala | 3551 |

5 | Um_nik | 3494 |

6 | Petr | 3452 |

7 | ksun48 | 3432 |

8 | jiangly | 3349 |

9 | maroonrk | 3338 |

10 | Miracle03 | 3314 |

# | User | Contrib. |
---|---|---|

1 | 1-gon | 211 |

2 | awoo | 188 |

3 | Errichto | 186 |

3 | rng_58 | 186 |

5 | SecondThread | 183 |

6 | Um_nik | 176 |

6 | Ashishgup | 176 |

8 | maroonrk | 173 |

9 | antontrygubO_o | 171 |

10 | -is-this-fft- | 169 |

CODEFESTIVAL site is updated with info about this year edition but only in Japanese.

Using Google Translate I read that this time only people living in Japan are allowed to participate (at least in the final round).

rng_58, can you confirm this?

Main reason for asking now is that the Finals date is 17.11 which is very close to TCO onsite dates (13.11-16.11).

I want to apologize once more for queue problems. It has also aggravated some tight ML/TL issues which probably would be not so big otherwise. I hope you enjoyed the problems nevertheless.

Tutorial is loading...

Tutorial is loading...

38799800 — logs

38799811 — case analisys

Tutorial is loading...

Tutorial is loading...

Tutorial is loading...

I hope that Petr is not mad at me for my joke.

Tutorial is loading...

38799850

38799853 — completely different solution with complexity *O*(6^{n / 2})

Tutorial is loading...

Tutorial is loading...

I hope that PrinceOfPersia is not mad at me for my joke.

Tutorial is loading...

Tutorial of Codeforces Round #485 (Div. 1)

Tutorial of Codeforces Round #485 (Div. 2)

Hello!

I'm glad to invite you all to Round 485 which will take place on Tuesday, May 29 at 18:35 UTC+3.

There will be 6 problems in each division, 3 of them are shared between divisions. 2 of div.2 problems created by KAN, 7 others created by me. The contest duration is 2 hours. My problems were originally used in HSE Championship.

I would like to thank Merkurev and GlebsHP with whom I discussed the problems, I_love_Tanya_Romanova for testing, KAN for round coordination and Codeforces and Polygon team for these beautiful platforms. I would also like to thank HSE for organizing the event. Oh, and kb. for writing great legend for one of the problems (he will be surprised).

For those who for some reason like to know score distribution in advance:

div.2: 500 — 1000 — 1250 — 1750 — 2250 — 3000

div.1: 500 — 1000 — 1750 — 2500 — 2750 — 3000

But I didn't properly discuss it with KAN so this is subject to change :)

UPD: Discussed with KAN, scores for C and D in div.2 increased by 250.

Good fun, have problems, read all the luck. As usual.

Oh, and if there will be no bad things, round will be rated. I hope.

I'm very sorry for issues with queue. I understand that it could ruin the contest for many of you. But please be understanding. Bad things happen. It could be some network problems or some electricity problems. MikeMirzayanov, KAN and other people behind Codeforces trying their best to provide good service. But sometimes it's very hard for some reasons. I hope that you enjoyed the problems despite all the bad things.

We decided that round will be **rated**.

Editorial will be posted tomorrow.

div.1 winners:

1. tourist

2. Retired_MiFaFaOvO

3. Radewoosh

4. webmaster

5. LHiC

div.2 winners:

1. sminem

2. Fortza_Gabi_Tulba

3. cheburazshka

4. McDonald

5. 2ez4me

Editorial is up.

Announcement of Codeforces Round #485 (Div. 1)

Announcement of Codeforces Round #485 (Div. 2)

Suppose we want to solve a problem by doing binary search on answer. Then the answer will be checked against jury's answer by absolute or relative error (one of them should be smaller then ε). For simplicity we will assume that our answer is always greater than 1 and smaller than *B*. Because of that, we will always use relative error rather than absolute.

Suppose we have made *n* iterations of our binary search — what information do we have now? I state that we know that real answer is lying in some segment [*x*_{i}, *x*_{i + 1}], where 1 = *x*_{0} < *x*_{1} < ... < *x*_{i} < ... < *x*_{2n} = *B*. And what is great — we can choose all *x*_{i} except for *x*_{0} and *x*_{2n}.

Now, for simplicity, we will also assume that we will answer *x*_{i + 1} for segment [*x*_{i}, *x*_{i + 1}] and the real answer was *x*_{i} — it is the worst case for us. It is obvious that we will not do that in real life, any other answer would be better, but you will get the idea.

So, what is our relative error? It is . Worst case for us is when relative error is maximal. It is logical to make them equal — exactly what we do by binary search with absolute errors. . We can assume that so . Now we have , but , so . How large should be *n* to get error less than ε? . Much smaller than .

How to write such binary search? We want to choose *m* in such a way that or simply .

Now I want to deal with some assumptions I made.

How to choose answer in the end? Again, (it is basically the same as dividing the segment in binary search).

What to do if the answer can be smaller than 1? Try 1; if answer is smaller than 1~--- use standard binary search (because absolute error smaller than relative); is answer is bigger than 1~--- use the binary search above.

P.S. I have never heard about this idea and come up with this while solving 744D - Hongcow Draws a Circle. I'm sorry if it is known for everyone except for me.

If you are registered on Timus, then you should have been received e-mail with invitation to this contest. The contest will be on 19 November in 11 Moscow time.

It was a junior championship but it was 'a little' harder than it was intended. As I remember, Merkurev solved all the problems with only 15 minutes to go, so I think that this contest may be interesting for participants with different levels, up to the strongest ACM teams.

The duration is 5 hours, standard ACM rules. It is a team (up to 3 participants) contest but you are welcome to partcipate individually too.

The authors of the problemset are Um_nik, Umqra, kb., Tinsane and crassirostris.

Hello!

October Clash on HackerEarth has started and you have 23 more hours to go.

I am the author of this problemset and niyaznigmatul is a tester. I want to thank Umqra who helped me a lot with preparation.

I hope you find the problems interesting and wish you good luck!

Q1: I'm a newbie. What should I do to become great coder?

A1: ~~Stop doing competetive programming~~ Solve problems.

Q2: I'm doing CP for two months and I'm still ~~not red~~ green. What should I do?

A2: ~~You are lazy and impatient~~ Solve more problems.

Q3: You became a red in less than two years, it is unbelievable!

A3: No, it isn't. ~~You can do it too if you will solve fucking problems.~~

Q4: You became a red blah-blah-blah such a huge fan blah-blah. Oh, and what should I do to become as great as you?

A4: ... right. You already know the answer. Solve problems. ~~I hate you.~~

Q5: I'm not good at DP [or something]. What can you suggest?

A5. Maybe you should try to ~~stop asking stupid questions and~~ solve some problems on DP? Or read some blogs and editorials.

Q6: I can't solve a problem / understand your code. Can you help me?

(Well, it is not a bad question in general. It is a good (if you really want me to explain something not to write the solution instead of you) question. But...)

A6: Sure. Can you provide the link to the problem / code?

(I'm not joking, it is a real story).

Bonus!

Q0: Hello bro/sir.

A0: Stop doing this please.

Access to the specified resource has been forbidden.

Codeforces said 20 minutes ago when I was trying to login. The same was about two weeks ago. In both cases I was unable to login for about 10 minutes.

And I constantly logout. Sometimes I can't read 3-4 blog posts before logout.

There were a post about logouting two or three days ago but I can't find it now because search is not working too.

I've noticed during the contest that we can see all the hacks in our room.

Now MikeMirzayanov says that it was a bug and will be fixed soon.

I think it really will be bad if there are tons of hacks. But it is very useful to know which problems can be hacked (I mean which problems was already hacked by someone). Can you add number of successfull and unsuccessfull hacks on each problem to the PROBLEMS page?

I would like to invite you to participate in Ural Regional School Programming Contest.

It is the Ural's qualifying round for All-Russian School Programming Contest and I think that it can be good opportunity for schoolboys to take part in this contest. It will be interesting for students too, I suppose.

Contest starts at 17 October 11:00 MSK at the same time with the onsite contest.

The problemsetters are Um_nik, Umqra, kb., hx0, Merkurev, KuchumovIlya, droptable (spoiler: it's not about palindromes).

Duration of the contest is 5 hours, ACM ICPC rules. Problem statements will be both in Russian and English. Link to the contest page

Suppose we have downloaded *S* seconds of the song and press the 'play' button. Let's find how many seconds will be downloaded when we will be forced to play the song once more. . Hence *x* = *qS*.

Solution: let's multiply *S* by *q* while *S* < *T*. The answer is the amount of operations.

Complexity —

Let's look at the problem from another side: how many numbers can we leave unchanged to get permutation? It is obvious: these numbers must be from 1 to *n* and they are must be pairwise distinct. This condition is necessary and sufficient.

This problem can be solved with greedy algorithm. If me meet the number we have never met before and this number is between 1 and *n*, we will leave this number unchanged. To implement this we can use array where we will mark used numbers.

After that we will look over the array again and allocate numbers that weren't used.

Complexity — *O*(*n*).

It is known that amount of prime numbers non greater than *n* is about .

We can also found the amount of palindrome numbers with fixed length *k* — it is about which is .

Therefore the number of primes asymptotically bigger than the number of palindromic numbers and for every constant *A* there is an answer. Moreover, for this answer *n* the next condition hold: . In our case *n* < 10^{7}.

For all numbers smaller than 10^{7} we can check if they are primes (via sieve of Eratosthenes) and/or palindromes (via trivial algorithm or compute reverse number via dynamic approach). Then we can calculate prefix sums (π(*n*) and *rub*(*n*)) and find the answer using linear search.

For *A* ≤ 42 answer is smaller than 2·10^{6}.

Complexity — .

568B - Symmetric and Transitive

Let's find Johnny's mistake. It is all right in his proof except ``If '' part. What if there is no such *b* for an given *a*? Then obviously otherwise we'll take *b* = *a*.

We can see that our binary relation is some equivalence relation which was expanded by some "empty" elements. For "empty" element *a* there is no such *b* that .

Thus we can divide our solution into two parts:

Count the number of equivalence relations on sets of size 0, 1, ...,

*n*- 1For every size count the number of ways to expand it with some "empty" elements.

We can define equivalence relation using its equivalence classes.

So first part can be solved using dynamic programming: *dp*[*elems*][*classes*] — the numbers of ways to divide first *elems* elements to *classes* equivalence classes. When we handle next element we can send it to one of the existing equivalence classes or we can create new class.

Let's solve second part. Consider set of size *m*. We have found that there are *eq*[*m*] ways to build equivalence relation on this set. We have to add *n* - *m* "empty" elements to this set. The number of ways to choose their positions is *C*_{n}^{k}. We can calculate all the binomial coefficients using Pascal's triangle.

So the answer to the problem is .

Complexity — *O*(*n*^{2})

Suppose we have fixed letters on some positions, how can we check is there a way to select letters on other positions to build a word from the language? The answer is 2-SAT. Let's see: for every position there is two mutually exclusive options (vowel or consonant) and the rules are consequences. Therefore we can do this check in *O*(*n* + *m*) time.

Let's decrease the length of the prefix which will be the same as in *s*. Then the next letter must be strictly greater but all the next letters can be any. We can iterate over all greater letters and then check if we can made this word the word from the language (via 2-SAT). Once we have found such possibilty we have found the right prefix of the answer. After that we can increase the length of the fixed prefix in a similar way. This solution works in *O*(*nm*Σ ) time. We can divide this by Σ simply try not all the letter but only the smallest possible vowel and the smallest possible consonant.

And you should remember about the case when all the letters are vowel (or all the letters are consonant).

Complexity — *O*(*nm*)

Suppose, that solution exist. In case *n* ≤ *k* we can put one signpost on each road. In other case let's choose any *k* + 1 roads. By the Dirichlet's principle there are at least two roads among selected, which have common signpost. Let's simple iterate over all variants with different two roads. After choosing roads *a* and *b*, we will remove all roads, intersecting with *a* and *b* in common points and reduce *k* in our problem. This recursive process solves the problem (if solution exist).

Complexity of this solution — . If implement this solution carefully — you will get AC =)

But in case of TL we can add one improvement to our solution. Note, that if we find point, which belongs to *k* + 1 or more roads, then we must include this point to out answer. For sufficiently large *n* (for example, if *n* > 30*k*^{2}) this point always exist and we can find it using randomize algorithm. If solution exist, probability that two arbitrary roads are intersects in such a point not less than . Because of it, if we 100 times pick two random roads, then with probability such a point will be found and we can decrease *k*.

All operations better to do in integers.

Complexity — .

568E - Longest Increasing Subsequence

Let's calculate array *c*: *c*[*len*] — minimal number that can complete increasing subsequence of length *len*. (This is one of the common solution for LIS problem).

Elements of this array are increasing and we can add new element *v* to processed part of sequence as follows:

find such index

*i*that*c*[*i*] ≤*v*and*c*[*i*+ 1] ≥*v*let

*c*[*i*+ 1] =*v*

We can process this action in time.

When we handle a gap, we must try to insert all numbers from set *b*. If we sort elements of *b* in advance, then we can move with two iterators along arrays *b* and *c* and relax all needed values as explained above. This case requires *O*(*n* + *m*) time.

Authors implied solution with *O*(*n*) space complexity for answer restoring. We can do this in the following way:

Together with array

*c*we will store array*c*_{index}[*len*] — index of element, which complete optimal increasing subsequence of length*len*. If this subsequence ends in a gap — we will store - 1.Also, we will store for every not gap — length of LIS(

*lenLIS*[*pos*]), which ends in this position (this is simply calculating while processing array*c*) and position(*prevIndex*[*pos*]) of previous element in this subsequence (if this elements is gap, we store - 1)

Now we will start recovery the answer with this information.

While we are working with not gaps — it's all right. We can simply restore LIS with *prevIndex*[*pos*] array. The main difficulty lies in processing gaps. If value of *prevIndex*[*pos*] in current position equal to - 1 — we know, that before this elements must be one or more gaps. And we can determine which gaps and what values from *b* we must put in them as follows:

Let suppose that we stand at position *r* (and *prevIndex*[*r*] = - 1). Now we want to find such position *l* (which is not gap), that we can fill exactly *lenLIS*[*r*] - *lenLIS*[*l*] gaps between *l* with increasing numbers from interval (*a*[*l*]..*a*[*r*]). Position *l* we can simply iterates from *r* - 1 to 0 and with it calculating gaps between *l* and *r*. Check the condition described above we can produce via two binary search query to array *b*.

Few details:

How do we know, that between positions

*l*and*r*we can fill gaps in such a way, that out answer still the best?

Let*countSkip*(*l*,*r*) — count gaps on interval (*l*..*r*),*countBetween*(*x*,*y*) — count different numbers from set*b*, lying in the range (*x*..*y*).

Then, positions*l*and*r*are good only if*lenLIS*[*r*] -*lenLIS*[*l*] =*min*(*countSkip*(*l*,*r*),*countBetween*(*a*[*l*],*a*[*r*])).*countSkip*we can calculate while iterates position*l*,*countBetween*(*x*,*y*) =*max*(0,*lower*_*bound*(*b*,*y*) -*upper*_*bound*(*b*,*x*)).What to do, is LIS ends or begins in gaps?

This case we can solve by simply adding - ∞ and + ∞ in begin and end of out array.

Complexity — . Memory — *O*(*n* + *m*).

Tutorial of Codeforces Round #315 (Div. 1)

Tutorial of Codeforces Round #315 (Div. 2)

Hello everyone!

Codeforces Round #315 will take place soon. The authors of this round are students of Ural FU Umqra and Um_nik. This is our second round. First one was in the black days of Codeforces and we hope that this will not happen again after our round :)

We want to thank Codeforces team for great Codeforces and Polygon platforms and Zlobober for helping us prepare this round.

Good luck!

**UPD1:**

Score distribution.

div2 : 500-1000-1500-2250-2750

div1 : 500-1000-1500-2250-2500

We strongly recommend you to read **all** the problems. We try our best to prepare different problems and some problems that hard for us can be easy for you.

**UPD2:**

Editorial

**UPD3:**

Congratulations to the winners!

div1:

1. KAN

2. Petr

3. enot110

4. tonyjjw

5. conflict

div2:

1. Lost

2. loser21

3. Aliquando

4. hqpwca

5. LazyWolfLin

Thank you for participating.

Announcement of Codeforces Round #315 (Div. 1)

Announcement of Codeforces Round #315 (Div. 2)

Codeforces (c) Copyright 2010-2021 Mike Mirzayanov

The only programming contests Web 2.0 platform

Server time: May/12/2021 07:44:28 (g1).

Desktop version, switch to mobile version.

Supported by

User lists

Name |
---|